package Libconf::GUI::Gtk2;

our @ISA = qw(Exporter);
%EXPORT_TAGS = (
    generators => [ qw(generateWidget getBestWidget) ],
    builders => [ qw(buildWidget) ],
);
$EXPORT_TAGS{all} = [ map { @$_ } values %EXPORT_TAGS ];
@EXPORT_OK = map { @$_ } values %EXPORT_TAGS;

use lib qw(/usr/lib/libDrakX);
#use interactive;
use common;
use Libconf;
use ugtk2 qw(:helpers :wrappers :create);

# public methods


# @widget_options is optional
sub getBestWidget {
    my ($struct, $key, @widget_options) = @_;
    my $data_description = $struct->{_data_description};
    my $data_mapping = $struct->{_data_mapping};
#    use Data::Dumper;
#    print Dumper($data_description) . "\n";
    my $a = "\$data_description->$key";
    print " +++ $a\n";
    $a = eval("\$data_description->$key");
    print " -- : " . Dumper($a). "\n";
    my $ret = buildWidget(eval("\$data_description->$key"), $data_mapping, @widget_options);
    $ret->set_value(eval("\$struct->$key"));
    $ret;
}


# @widget_options is optional
sub buildWidget {
    my ($data, $data_mapping, @widget_options) = @_;
    my ($type, $type2, $type3, $default, $values) = @{$data}{qw(type type2 type3 default values)};
    $data_mapping ||= {};
#    print "-- $type\n";
#     if ($type eq 'LIST') {
#         defined $type2 or die "ERROR : missing type2 for LIST type. key : $key, malformed template : . " $struct->{libconf}{template_name};
#         my @type2 = split('|', $type2);
#         if (@type2 == 1) { # we have an homogeneous list"
#         } else {
#         }
#     } els

    my $is_combo = 0;
    print " ------------ \n";
    use Data::Dumper;
    Dumper($values) . "\n";
    if (defined $values) {
        if (ref($values) eq 'CODE') {
            $values = &$values();
        }
        if (ref($values) eq 'ARRAY') {
            $is_combo = 1;
        }
    }

    if ($type eq 'BOOLEAN') {
        $ret = Libconf::GUI::Gtk2::CheckButton->new($default, $data_mapping->{BOOLEAN}, @widget_options);
    } elsif ($type eq 'INTEGER') {
        $ret = Libconf::GUI::Gtk2::SpinButton->new($default, $data_mapping->{BOOLEAN}, @widget_options);
    } elsif ($type eq 'STRING') {
        if ($is_combo) {
            $ret = gtkcombo_setpopdown_strings(Libconf::GUI::Gtk2::Combo->new($default, $data_mapping->{STRING}, @widget_options),
                                               @$values,
                                              );
        } else {
            $ret = Libconf::GUI::Gtk2::Entry->new($default, $data_mapping->{STRING}, @widget_options);
        }
    } else {
        $ret = Libconf::GUI::Gtk2::Entry->new($default, $data_mapping->{STRING}, @widget_options);
    }
    $ret;
}

#BOOLEAN
#COMMAND
#DIRECTORY
#DURATION
#ENCODING
#FILENAME
#INTEGER
#LIST
#PID
#STRING
#VERSION

sub generateWidget {
    my ($struct) = @_;
    my $vbox = Gtk2::VBox->new(0,10);
    my $notebook;
    my $n_page;
    my $table;
    if (UNIVERSAL::isa($struct, 'HASH')) {
        my $count = 0;
        while (my ($key, $value) = each %$struct) {
            if (UNIVERSAL::isa($value, 'HASH')) {
                if (!defined $notebook) {
                    $notebook = initialize_notebook($vbox);
                    $n_page = 0;
                }
                $notebook->append_page(
                                       my $child = generateWidget($value),
                                       gtkpack_(Gtk2::HBox->new(0,5),
                                                1, new Gtk2::Label($key),
                                                0, gtksignal_connect(# gtkadd(
                                                                     Gtk2::Button->new('X'),
                                                                     #gtkcreate_pixbuf('eth_card_mini2.png')
                                                                     #),
                                                                     clicked => sub {
                                                                         my $n_page = $_[1];
                                                                         if (create_dialog(N('Do you really want to remove this section?'))) {
                                                                             print "  - $n_page\n";
                                                                             $notebook->remove_page($n_page);
                                                                             delete $struct->{$key};
                                                                         }
                                                                     }, $n_page
                                                                    )
                                               ),
                                      );
                $n_page++;
            } else {
                $table ||= initialize_table($vbox);
                $table->attach(gtkpack_(Gtk2::HBox->new(0,0),
                                        1, Gtk2::HBox->new(0,0),
                                        0, Gtk2::Label->new($key)
                                       ),
                               0, 1, $count, $count + 1,
                               'fill',
                               ['shrink', 'shrink'],
                               0, 0);
                $table->attach(generateWidget($value), 1, 2, $count, $count + 1,
                               ['fill', 'expand'],
                               ['shrink', 'shrink'],
                               0, 0);
            }
            $count++;
        }
        $vbox->show_all();
        return $vbox;
    }
    if (UNIVERSAL::isa($struct, 'ARRAY')) {
        my $tree_model = Gtk2::TreeStore->new("Glib::String");
        my $list = Gtk2::TreeView->new_with_model($tree_model);
        $list->append_column(Gtk2::TreeViewColumn->new_with_attributes(N("list"), Gtk2::CellRendererText->new, 'text' => 0));
        foreach my $element (@$struct) {
            $tree_model->append_set(undef, [ 0 => $element ]);
        }
        $list->show_all();
        return $list;
    }
    return gtkshow(gtkentry($struct));
}

# private methods

sub initialize_notebook {
    gtkpack_(shift, 0, my $notebook = new Gtk2::Notebook);
    #        $notebook->set_tab_pos('left');
    $notebook;
}

sub initialize_table {
    gtkpack_(shift,
             0, gtkset_border_width(gtkset_shadow_type(gtkadd(Gtk2::Frame->new(N("test")),
                                                              my $table = Gtk2::Table->new(0, 2, 0),
                                                             ),
                                                       'etched_out'),
                                    5),
            );
    $table->set_col_spacings(5);
    $table->set_row_spacings(5);
    $table;
}

sub create_dialog {
    my ($label) = @_;
    my $ret;
    my $dialog = new Gtk2::Dialog();
    $dialog->set_position('center');
    $dialog->set_position('center-on-parent');
    $dialog->vbox->set_border_width(10);
    $dialog->signal_connect(delete_event => sub { Gtk2->main_quit() });
    $dialog->vbox->pack_start(new Gtk2::Label($label),1,1,0);
    my $bbox_dialog = new Gtk2::HButtonBox;
    $dialog->action_area->add($bbox_dialog);
    $bbox_dialog->set_layout('end');
    $bbox_dialog->add(
                      gtksignal_connect(new Gtk2::Button(N("OK")), 
                                        clicked => sub {
                                            $ret = 1;
                                            Gtk2->main_quit();
                                        })
                     );
    $bbox_dialog->add(
                      gtksignal_connect(new Gtk2::Button(N("Cancel")), 
                                        clicked => sub {
                                            Gtk2->main_quit();
                                        })
                     );
    $dialog->show_all;
    $dialog->set_modal(1);
    Gtk2->main();
    $dialog->destroy;
    $ret;
}

package Libconf::GUI::Gtk2::SpinButton;

use ugtk2 qw(:helpers :wrappers :create);

our @ISA = qw(Gtk2::SpinButton);

sub new {
    print " - ********************************* new spin\n";
    my ($class, $default, $data_mapping, @widget_options) = @_;
    my $adj = create_adjustment(0, 0, 65535);
    my $self = $class->SUPER::new($adj, 1, 0, @widget_options);
    $self->{default_value} = $default;
    $self->{data_mapping} = $data_mapping;
    bless $self, $class;
#     gtksignal_connect($self->entry, changed => sub {
#                           my ($widget) = @_;
#                           my $value = $widget->get_text();
#                           print " setting : -- " . $value . "\n";
#                           $self->{value} = $value;
#                           print " getvalue : -- " . $self->get_value() . "\n";
#                       });
    print " - end new spin\n";
    return $self;
}

sub set_default {
    my ($self) = @_;
#    my $default_value = $self->get_data('default_value');
    my $default_value = $self->{'default_value'};
    $self->set_value($default_value);
#    defined $self->{'data_mapping'} and $default_value = $self->{'data_mapping'}->($default_value);
    $self->{'value'} = $default_value;
#    $self->set_data('value', $default_value);
}

sub set_value {
    my ($self, $value) = @_;
#    $self->set_data('value', $value);
    $self->{value} = $value;
    Gtk2::SpinButton::set_value($self, $value);
#    $self->set_text($value);
#    defined $self->{'data_mapping'} and $value = $self->{'data_mapping'}->($value);
#    $self->set_active($value);
}

sub get_value {
    my ($self) = @_;
#    my $value = $self->get_data('value');
    my $value = $self->{value};
#    defined $self->{'data_mapping'} and $value = $self->{'data_mapping'}->($value);
    $value;
}


package Libconf::GUI::Gtk2::Combo;

use ugtk2 qw(:helpers :wrappers :create);

our @ISA = qw(Gtk2::Combo);

sub new {
    my ($class, $default, $data_mapping, @widget_options) = @_;
    my $self = $class->SUPER::new(@widget_options);
    $self->{default_value} = $default;
    $self->{data_mapping} = $data_mapping;
    bless $self, $class;
    gtksignal_connect($self->entry, changed => sub {
                          my ($widget) = @_;
                          my $value = $widget->get_text();
                          print " setting : -- " . $value . "\n";
                          $self->{value} = $value;
                          print " getvalue : -- " . $self->get_value() . "\n";
                      });
    return $self;
}

sub set_default {
    my ($self) = @_;
#    my $default_value = $self->get_data('default_value');
    my $default_value = $self->{'default_value'};
    $self->entry->set_text($default_value);
#    defined $self->{'data_mapping'} and $default_value = $self->{'data_mapping'}->($default_value);
    $self->{'value'} = $default_value;
#    $self->set_data('value', $default_value);
}

sub set_value {
    my ($self, $value) = @_;
#    $self->set_data('value', $value);
    $self->{value} = $value;
    $self->entry->set_text($value);
#    $self->set_text($value);
#    defined $self->{'data_mapping'} and $value = $self->{'data_mapping'}->($value);
#    $self->set_active($value);
}

sub get_value {
    my ($self) = @_;
#    my $value = $self->get_data('value');
    my $value = $self->{value};
#    defined $self->{'data_mapping'} and $value = $self->{'data_mapping'}->($value);
    $value;
}



package Libconf::GUI::Gtk2::CheckButton;

use ugtk2 qw(:helpers :wrappers :create);

our @ISA = qw(Gtk2::CheckButton);

#constructor
#@widget_options is optional
sub new {
    my ($class, $default, $data_mapping, @widget_options) = @_;
    my $self = $class->SUPER::new(@widget_options);

#    $self->set_data('default_value', $default);
    $self->{'default_value'} = $default;
#    $self->set_data('data_mapping', $data_mapping);
    $self->{'data_mapping'} = $data_mapping;
    bless $self, $class;
#    $self->set_default();
#    print " -- " . $self->get_data('value') . "\n";
    print " -- " . $self->{'value'} . "\n";
    gtksignal_connect($self, toggled => sub {
                          my ($widget) = @_;
                          my $value = $widget->get_active;
                          defined $data_mapping and $value = $data_mapping->($value);
                          $self->set_value($value);
                          print " getvalue : -- " . $self->get_value() . "\n";
                      });
    return $self;
}

#### TO BE REWORKED, data mapping is bad
sub set_default {
    my ($self) = @_;
#    my $default_value = $self->get_data('default_value');
    my $default_value = $self->{'default_value'};
    $self->set_active($default_value);
#    defined $self->{'data_mapping'} and $default_value = $self->{'data_mapping'}->($default_value);
    $self->{'value'} = $default_value;
#    $self->set_data('value', $default_value);
}

sub set_value {
    my ($self, $value) = @_;
#    $self->set_data('value', $value);
    $self->{'value'} = $value;
    defined $self->{'data_mapping'} and $value = $self->{'data_mapping'}->($value);
    $self->set_active($value);
}

sub get_value {
    my ($self) = @_;
#    my $value = $self->get_data('value');
    my $value = $self->{'value'};
#    defined $self->{'data_mapping'} and $value = $self->{'data_mapping'}->($value);
    $value;
}

package Libconf::GUI::Gtk2::Entry;

use ugtk2 qw(:helpers :wrappers :create);

our @ISA = qw(Gtk2::Entry);

#constructor
#@widget_options is optional
sub new {
    my ($class, $default, $data_mapping, @widget_options) = @_;

    #call the constructor of the parent class.
    my $self = $class->SUPER::new(@widget_options);
    $self->{'default_value'} = $default;
    bless $self, $class;
    return $self;
}

#### TO BE REWORKED : data mapping is badly implemented
sub set_default {
    my ($self) = @_;
    my $default_value = $self->{'default_value'};
    $self->set_text($default_value);
    $self->{'value'} = $default_value;
#    defined $self->{'data_mapping'} and $default_value = $self->{'data_mapping'}->($default_value);
#    $self->set_data('value', $default_value);
}

sub set_value {
    my ($self, $value) = @_;
#    $self->set_data('value', $value);
    $self->{'value'} = $value;
    $self->set_text($value);
#    defined $self->{'data_mapping'} and $value = $self->{'data_mapping'}->($value);
#    $self->set_active($value);
}

sub get_value {
    my ($self) = @_;
#    my $value = $self->get_data('value');
    my $value = $self->{'value'};
#    defined $self->{'data_mapping'} and $value = $self->{'data_mapping'}->($value);
    $value;
}
